;*************************************
;*            DISCO Light            *
;*************************************

list p=p16F84, r=dec                                    ;16F84-es uC s decimlis szmrendszer

#include <P16F84.inc>					;Regiszterek nevt tartalmazza

;Konstansok
K1			equ		2		;K1 bemenet 1-es lb
K2			equ		3		;K2 bemenet 2-es lb
J1			equ		0		;J1 kimenet 6-os lb
J2			equ		1		;J2 kimenet 7-es lb
J3                      equ             3               ;J3 kimenet 9-es lb
J4                      equ             4               ;J4 kimenet 10-es lb
X			equ		2		;X kimenet  8-as lb
A_PORT			equ		0x1F		;A PORT mind bemenet 
B_PORT			equ		B'11100000'	;B PORT 0,1,2,3,4 kimenet a tbbi bemenet

;Vltozk (szabadon felhasznlhat regiszterek)
FLSH_CNTR		equ		0x0C		;Villogs szmll
D770			equ		0x0D		;Ksleltshez szksges trolk
D200			equ		0x0E		;
K2_CNTR			equ		0x0F		;K2 kapcsolszmll
C1                      equ             0x10

;Program
			org		0		;Resetkor ide ugrik
Start	
			goto	        init	        ;A vezrl inicializlsa

			org		4		;Megszaktsi vektor	
			retfie	        		;Nem hasznlok megszaktst, de ha mgis megtrtnne (elhagyhat)
init
                        bcf             STATUS,RP0      ;0-s regiszterbank kivlasztsa
                        clrf            PORTA           ;Portok trlse
                        clrf            PORTB
			bsf		STATUS,RP0	;1-es regiszterbank kivlasztsa
			movlw	        A_PORT		;Portok irnynak belltsa
			movwf	        TRISA
			movlw	        B_PORT
			movwf	        TRISB		
			movlw	        0xC0		;OPTION regiszter belltsa
			movwf	        OPTION_REG
			bcf		STATUS,RP0	;0-s regiszterbank kivlasztsa	
			movlw           B'00011111'     ;Kimenetek 1-be lltsa a negetv logika miatt
			movwf           PORTB
			clrf            C1
main							;Fprogram
			call 	        first		;K1 kapcsol figyelse + 100 villogs
loop_main                                               ;Fciklus
                       	movlw	        .4               ;K2 kapcsolsi szmnak bellts a szmllban
			movwf	        K2_CNTR 
			movlw	        .13              ;Villogsok szmnak belltsa
			movwf	        FLSH_CNTR
			call	        K2_LED          ;K2 figyelse + LED villogtatsa
				
			movlw	        .4               ;gyanaz j rtkekkel
			movwf	        K2_CNTR
			movlw	        .25
			movwf	        FLSH_CNTR
			call	        K2_LED
				
			movlw	        .10              ;gyanaz j rtkekkel
			movwf	        K2_CNTR
			movlw	        .25
			movwf	        FLSH_CNTR
			call	        K2_LED
				
			bsf		PORTB,J1        ;J1 1-be
			bcf		PORTB,J2        ;J2 0-ba

			movlw	        .10              ;Ismt j rtkkel a kapcsol villog
			movwf	        K2_CNTR
			movlw	        .12
			movwf	        FLSH_CNTR
			call	        K2_LED

			movlw	        .10              ;gyanaz j rtkekkel
			movwf	        K2_CNTR
			movlw	        .25
			movwf	        FLSH_CNTR
			call	        K2_LED

			bsf		PORTB,J2        ;J2 1-be
			bcf		PORTB,J1        ;J1 0-ba

			movlw	        .15              ;Ismt j rtkkel a kapcsol villog
			movwf	        K2_CNTR
			movlw	        .25
			movwf	        FLSH_CNTR
			call	        K2_LED

			movlw	        .15              ;gyanaz j rtkekkel
			movwf	        K2_CNTR
			movlw	        .25
			movwf	        FLSH_CNTR
			call	        K2_LED

			movlw	        .15              ;gyanaz j rtkekkel
			movwf	        K2_CNTR
			movlw	        .12
			movwf	        FLSH_CNTR
			call	        K2_LED

			movlw	        .15              ;gyanaz j rtkekkel
			movwf	        K2_CNTR
			movlw	        .13
			movwf	        FLSH_CNTR
			call	        K2_LED

			bsf		PORTB,J1        ;J1 1-be
			bcf		PORTB,J2        ;J2 0-ba

			movlw	        .25              ;Ismt j rtkkel a kapcsol villog
			movwf	        K2_CNTR
			movlw	        .38
			movwf	        FLSH_CNTR
			call	        K2_LED

			movlw	        .25              ;gyanaz j rtkekkel
			movwf	        K2_CNTR
			movlw	        .25
			movwf	        FLSH_CNTR
			call	        K2_LED

			movlw	        .25              ;gyanaz j rtkekkel
			movwf	        K2_CNTR
			movlw	        12
			movwf	        FLSH_CNTR
			call	        K2_LED

			movlw	        .25              ;gyanaz j rtkekkel
			movwf	        K2_CNTR
			movlw	        .13
			movwf	        FLSH_CNTR
			call	        K2_LED

 			bsf		PORTB,J2        ;J2 1-be
			bcf		PORTB,J1        ;J1 0-ba
				
			goto	        loop_main       ;s a ciklus kezddik ellrl

K2_LED                                                  ;K2 kapcsol szmol s villogtat rutin 
			call	        read_K2         ;Vr egy alacsony magas vltsra 
			decfsz	        K2_CNTR,F       ;Megvolt-e a szksges kapcsols?
			goto 	        K2_LED          ;Ha nem vissza a kapcsol vrshoz
			call	        blink           ;Ha igen villoghat a LED
			return

first                                                   ;K1 figyelse + 100 villogs
			bcf		PORTB,J1        ;J1 0-ba lltsa
wait_strt		
                        movlw           .1
                        movwf           FLSH_CNTR
                        call            blink	
			btfsc	        PORTA,K1        ;Vr amg K1 alacsony nem lesz
			goto	        wait_strt
			movlw	        100             ; Villogsi szm belltsa
			movwf	        FLSH_CNTR
			call	        blink           ;LED villogtatsa
			return

blink                                                   ;LED villogtat rutin
			bcf		PORTB,X         ;X 0-ba lltsa
			call 	        dly_100m        ;kb. 100ms vrakozs 
			bsf		PORTB,X         ;X 1-be lltsa
			call	        dly_100m        ;Ismt 100ms vrakozs azaz 5 villans msodpercenknt
			decfsz          FLSH_CNTR,F     ;Vegvolt-e a villansi szm?
			goto	        blink           ;Ha nem akkor vissza az elejre
			return                          ;Ha igen vissza rutin vge

dly_100m                                                ;Olyan 100,1 ms valjban 4MHz-es kristlyal
			movlw	        .130		;130-szor futtat le egy 770us-os ksleltetst
			movwf	        D200            ;Nvelve a 130-at a villogs lassthat (0 rtknl 256-szor 770us)
loop_100m
			call	        dly_770u        ;770us vrakozs
			decfsz          D200,F          ;Megvolt-e a 130 ciklus
			goto	        loop_100m       ;Ha nem ujra futtats
			return                          ;Ha igen letelt az id
			
dly_770u                                                ;Ez valjban 772us ksleltets
			clrf	        D770            ;Szmll nullzsa ez 256 ciklust eredmnyez
loop_770u
			decfsz	        D770,F          ;Megvolt a 256 ciklus
			goto 	        loop_770u       ;Ha nem visszaugrik
			return                          ;Ha igen vge a rutinnak

read_K2	                                                ;Vrakozs a K2 bemenet alacsonyra ,majd magasra vltsra
			btfsc	        PORTA,K2        ;Alacsony K2?
			goto	        read_K2         ;Nem, jra lekrdezs
w_K2
			btfss	        PORTA,K2        ;Magas K2?
			goto	        w_K2            ;Nem vissza a lekrdezshez
			call            j_blink
			return                          ;Igen, akkor vge a rutinnak

j_blink
                        incf            C1
                        movlw           .4
                        subwf           C1,W
                        bnc             j3_b
                        movlw           .8
                        subwf           C1,W
                        bnc             j4_b
                        movlw           .15
                        subwf           C1,W
                        bnc             j3_b
                        movlw           .18
                        subwf           C1,W
                        bnc             j4_b
                        clrf            C1
j3_b
                        movf            PORTB,W
                        xorlw           B'00001000'
                        movwf           PORTB
                        return
j4_b
                        movf            PORTB,W
                        xorlw           B'00010000'
                        movwf           PORTB
                        return

END